<?php
/**
 * [PHPFOX_HEADER]
 */

defined('PHPFOX') or exit('NO DICE!');

/**
 * Callbacks
 *
 * @copyright		[PHPFOX_COPYRIGHT]
 * @author  		Raymond Benc
 * @package  		Module_Admincp
 * @version 		$Id: callback.class.php 1586 2010-05-17 17:10:46Z Raymond_Benc $
 */
class Admincp_Service_Callback extends Phpfox_Service
{
	public function massAdmincpProductDelete($sProduct)
	{
		$aTables = array(
			'block',			
			'component',
			'cron',
			'menu',
			'plugin',
			'plugin_hook',
			'setting',
			'setting_group',
			'site_stat'
		);

		foreach ($aTables as $sTable)
		{
			$this->database()->delete(Phpfox::getT($sTable), "product_id = '" . $this->database()->escape($sProduct) . "'");
		}

		$aModules = $this->database()->select('module_id')
			->from(Phpfox::getT('module'))
			->where("product_id = '" . $this->database()->escape($sProduct) . "'")
			->execute('getRows');

		foreach ($aModules as $aModule)
		{
			Phpfox::getService('admincp.module.process')->delete($aModule['module_id']);
		}
	}

	public function massAdmincpModuleDelete($iModule)
	{
		$aTables = array(
			'block',
			'component',
			'cron',
			'menu',
			'module',
			'plugin',
			'plugin_hook',
			'setting',
			'setting_group'
		);

		foreach ($aTables as $sTable)
		{
			$this->database()->delete(Phpfox::getT($sTable), "module_id = '" . $this->database()->escape($iModule) . "'");
		}
	}
	
	public function getDetailOnOrderUpdate()
	{
		return array(
			'table' => 'admincp_dashboard',
			'field' => 'user_id',
			'value' => Phpfox::getUserId()
		);		
	}

	public function removeDuplicateList()
	{
		$aList = array();
		
		$aList[] = array(
			'name' => Phpfox::getPhrase('admincp.menus'),
			'key' => 'menu_id',
			'table' => 'menu',
			'search' => array(
				'm_connection',
				'module_id',
				'var_name'
			)
		);
				
		$aList[] =	array(
			'name' => Phpfox::getPhrase('admincp.blocks'),
			'key' => 'block_id',
			'table' => 'block',
			'search' => array(
				'm_connection',
				'module_id',
				'component',
				'location'
			)					
		);
		
		$aList[] =	array(
			'name' => Phpfox::getPhrase('admincp.global_settings'),
			'key' => 'setting_id',
			'table' => 'setting',
			'search' => array(
				'group_id',
				'module_id',
				'var_name'
			)					
		);			
			
		$aList[] =	array(
			'name' => Phpfox::getPhrase('admincp.modules'),
			'key' => 'module_id',
			'table' => 'module',
			'search' => array(
				'module_id'				
			)					
		);		
		
		return $aList;
	}		
}

?>