<?php
/**
 * [PHPFOX_HEADER]
 */

defined('PHPFOX') or exit('NO DICE!');

/**
 * 
 * 
 * @copyright		[PHPFOX_COPYRIGHT]
 * @author  		Raymond Benc
 * @package  		Module_Comment
 * @version 		$Id: display.class.php 2584 2011-04-29 09:03:52Z Raymond_Benc $
 */
class Comment_Component_Block_Display extends Phpfox_Component 
{
	/**
	 * Class process method wnich is used to execute this component.
	 */
	public function process()
	{
		(($sPlugin = Phpfox_Plugin::get('comment.component_block_display_process_start')) ? eval($sPlugin) : false);		
		
		if (defined('PHPFOX_IS_USER_PROFILE'))
		{			
			if (!Phpfox::getParam('comment.allow_comments_on_profiles'))
			{
				return false;
			}
			
			$aUser = $this->getParam('aUser');
			if (!Phpfox::getService('user.privacy')->hasAccess($aUser['user_id'], 'comment.view_comment'))
			{
				return false;
			}
		}		
		
		$sType = $this->getParam('sType');
		$iItemId = $this->getParam('iItemId');
		$bCanPostOnItem = Phpfox::getUserParam(Phpfox::callback($sType . '.getAjaxCommentVar'));
		
		if ($sType == 'group' && !Phpfox::getService('group')->hasAccess($iItemId, 'can_use_comments'))
		{
			return false;
		}
		
		if ($sType == 'group' && !Phpfox::getService('group')->hasAccess($iItemId, 'can_use_comments', true))
		{
			$bCanPostOnItem = false;
		}
		
		$aValidation = array(
			'text' => Phpfox::getPhrase('comment.fill_text_your_comment')
		);
		
		if (Phpfox::isModule('captcha') && Phpfox::getUserParam('captcha.captcha_on_comment'))
		{
			$aValidation['image_verification'] = Phpfox::getPhrase('captcha.complete_captcha_challenge');
		}
		
		if ($bCanPostOnItem && Phpfox::getUserParam('comment.can_post_comments') && !Phpfox::getUserId())
		{
			$aValidation['author'] = Phpfox::getPhrase('comment.fill_in_your_name');
			$aValidation['author_email'] = array('def' => 'email');
		}
		
		(($sPlugin = Phpfox_Plugin::get('comment.component_block_display_process_validation')) ? eval($sPlugin) : false);

		$oValid = Phpfox::getLib('validator')->set(array('sFormName' => 'js_comment_form', 'aParams' => $aValidation));		
	
		(($sPlugin = Phpfox_Plugin::get('comment.component_block_display_process_middle')) ? eval($sPlugin) : false);
		
		if (defined('PHPFOX_IS_USER_PROFILE'))
		{			
			if (!Phpfox::getService('user.privacy')->hasAccess($aUser['user_id'], 'comment.add_comment'))
			{
				$bCanPostOnItem = false;
			}		
			
			if (Phpfox::getUserId() == $aUser['user_id'])
			{
				$this->template()->assign('sDeleteBlock', 'profile');
			}
		}		
		
		if (Phpfox::getParam('comment.allow_rss_feed_on_comments') && Phpfox::isModule('rss'))
		{
			//$this->template()->assign('sBlockTitleBar', '<div class="js_edit_header_bar"><a href="' . Phpfox::getLib('url')->makeUrl('comment', array('rss', 'type' => $sType, 'item' => $iItemId)) . '" title="Subscribe to Comments.">' . Phpfox::getLib('image.helper')->display(array('theme' => 'rss/tiny.png', 'class' => 'v_middle')) . '</a></div>');
			$this->template()->assign('sBlockTitleBar', '<div class="js_edit_header_bar"><a href="' . Phpfox::getLib('url')->makeUrl('comment', array('rss', 'type' => $sType, 'item' => $iItemId)) . '" title="'.Phpfox::getPhrase('comment.subscribe_to_comments').'">' . Phpfox::getLib('image.helper')->display(array('theme' => 'rss/tiny.png', 'class' => 'v_middle')) . '</a></div>');
		}
		
		$this->template()->assign(array(
				'sHeader' => Phpfox::getPhrase('comment.comment_title'),
				'sType' => $sType,
				'iItemId' => $iItemId,
				'sCreateJs' => $oValid->createJS(),
				'sGetJsForm' => $oValid->getJsForm(false),
				'bCanPostOnItem' => $bCanPostOnItem,
				'bViewComment' => $this->request()->getInt('comment')
			)
		);
		
		(($sPlugin = Phpfox_Plugin::get('comment.component_block_display_process_end')) ? eval($sPlugin) : false);
		
		return 'block';
	}
	
	/**
	 * Garbage collector. Is executed after this class has completed
	 * its job and the template has also been displayed.
	 */
	public function clean()
	{
		(($sPlugin = Phpfox_Plugin::get('comment.component_block_display_clean')) ? eval($sPlugin) : false);
	}
}

?>