<?php
/**
 * [PHPFOX_HEADER]
 */

defined('PHPFOX') or exit('NO DICE!');

/**
 * 
 * 
 * @copyright		[PHPFOX_COPYRIGHT]
 * @author  		Raymond Benc
 * @package  		Module_Friend
 * @version 		$Id: index.class.php 3107 2011-09-15 12:01:25Z Raymond_Benc $
 */
class Friend_Component_Controller_Index extends Phpfox_Component
{
	/**
	 * Class process method wnich is used to execute this component.
	 */
	public function process()
	{		
		Phpfox::isUser(true);
		
		if (($iDeleteList = $this->request()->getInt('dlist')) && Phpfox::getService('friend.list.process')->delete($iDeleteList))
		{
			$this->url()->send('friend', true, 'List successfully deleted.');
		}
		
		$sView = $this->request()->get('view');
		$iPage = $this->request()->getInt('page');		
		$this->template()->setTitle('Friends')->setBreadcrumb('Friends', $this->url()->makeUrl('friend'));
			
		$aSort = array();
		if ($sView == 'list')
		{
			$aSort['custom'] = array(
				'fld.ordering', 'Custom Order'
			);
		}
		
		$aSort['latest'] = array('friend.time_stamp', 'Newest Friends');
		$aSort['first-name'] = array('u.full_name', 'By First Name', 'ASC');
					
		$aParams = array(
				'type' => 'friend',
				'field' => 'friend.friend_id',				
				'search_tool' => array(
					'table_alias' => 'friend',
					'search' => array(
						'action' =>  $this->url()->makeUrl('friend', array('view' => $this->request()->get('view'))),
						'default_value' => 'Search Friends...',
						'name' => 'search',
						'field' => 'u.full_name'
					),
					'sort' => $aSort,
					'show' => array(10, 15, 20)
				)
			);					
		
		$this->search()->set($aParams);	

		$iPageSize = $this->search()->getDisplay();

		$bIsOnline = false;
		$iListId = 0;
		$aSend = null;
		$aList = array();
		switch ($sView)
		{
			case 'list':
				if (($iListId = $this->request()->getInt('id')) && ($aList = Phpfox::getService('friend.list')->getList($iListId, Phpfox::getUserId())) && isset($aList['list_id']))
				{
					$this->search()->setCondition('AND fld.list_id = ' . (int) $aList['list_id'] . ' AND friend.user_id = ' . Phpfox::getUserId());
					$aSend = array('list' => $iListId);
					$this->template()->setTitle($aList['name'])->setBreadcrumb($aList['name'], $this->url()->makeUrl('friend', array('view' => 'list', 'id' => $iListId)), true);
				}
				else
				{
					return Phpfox_Error::display(Phpfox::getPhrase('friend.invalid_friend_list'));
				}				
				break;
			default:
				$this->search()->setCondition('AND friend.is_page = 0 AND friend.user_id = ' . Phpfox::getUserId());
				break;
		}
		
		if (($aVals = $this->request()->getArray('val')) && isset($aVals['id']) && is_array($aVals['id']))
		{
			$oServiceFriendProcess = Phpfox::getService('friend.process');
			foreach ($aVals['id'] as $iId)
			{
				$oServiceFriendProcess->delete($iId);
			}
			
			$this->url()->send('friend', $aSend, Phpfox::getPhrase('friend.successfully_deleted'));
		}
		
		list($iCnt, $aRows) = Phpfox::getService('friend')->get($this->search()->getConditions(), $this->search()->getSort(), $this->search()->getPage(), $iPageSize, true, true, $bIsOnline, null, true);		
		
		Phpfox::getLib('pager')->set(array('page' => $iPage, 'size' => $iPageSize, 'count' => $iCnt, 'ajax' => 'friend.viewMoreFriends'));
		
		Phpfox::getService('friend')->buildMenu();
		
		$this->template()->setHeader('jquery/ui.js', 'static_script');
		$this->template()->setHeader('cache', array(
					'pager.css' => 'style_css',						
					'friend.js' => 'module_friend',
					'friend.css' => 'style_css'
				)
			)				
			->assign(array(
				'aFriends' => $aRows,
				'aList' => $aList,
				'iList' => $iListId,
				'sView' => $sView,
				'iTotalFriendRequests' => Phpfox::getService('friend.request')->getUnseenTotal()
			)
		);
	}
	
	/**
	 * Garbage collector. Is executed after this class has completed
	 * its job and the template has also been displayed.
	 */
	public function clean()
	{
		(($sPlugin = Phpfox_Plugin::get('friend.component_controller_index_clean')) ? eval($sPlugin) : false);
	}
}

?>