<?php
/**
 * [PHPFOX_HEADER]
 */

defined('PHPFOX') or exit('NO DICE!');

/**
 * 
 * 
 * @copyright		[PHPFOX_COPYRIGHT]
 * @author  		Raymond Benc
 * @package 		Phpfox_Component
 * @version 		$Id: profile.class.php 1220 2009-10-25 22:15:16Z Raymond_Benc $
 */
class Group_Component_Block_Profile extends Phpfox_Component
{
	/**
	 * Class process method wnich is used to execute this component.
	 */
	public function process()
	{
		$aUser = $this->getParam('aUser');
		
		if (!Phpfox::getService('user.privacy')->hasAccess($aUser['user_id'], 'group.display_on_profile'))
		{
			return false;
		}		
		
		$aGroups = Phpfox::getService('group')->getForProfileBlock($aUser['user_id']);

		if (!count($aGroups) && !defined('PHPFOX_IN_DESIGN_MODE'))
		{
			return false;
		}
		
		$this->template()->assign(array(
				'sHeader' => Phpfox::getPhrase('group.groups'),
				'sBlockJsId' => 'profile_group',
				'aGroups' => $aGroups
			)
		);
		
		if (count($aGroups) == 5)
		{
			$this->template()->assign('aFooter', array(
					Phpfox::getPhrase('group.view_more') => (Phpfox::getParam('group.group_profile_display') == 'both' ? $this->url()->makeUrl('group', array('user' => $aUser['user_id'])) : $this->url()->makeUrl('group', array('view' => 'owner', 'id' => $aUser['user_id'])))
				)
			);
		}
		
		if (Phpfox::getUserId() == $aUser['user_id'])
		{
			$this->template()->assign('sDeleteBlock', 'profile');
		}		
		
		return 'block';		
	}
	
	/**
	 * Garbage collector. Is executed after this class has completed
	 * its job and the template has also been displayed.
	 */
	public function clean()
	{
		(($sPlugin = Phpfox_Plugin::get('group.component_block_profile_clean')) ? eval($sPlugin) : false);
	}
	
	public function widget()
	{
		return true;
	}		
}

?>