<?php
/**
 * [PHPFOX_HEADER]
 */

defined('PHPFOX') or exit('NO DICE!');

/**
 * 
 * 
 * @copyright		[PHPFOX_COPYRIGHT]
 * @author  		Raymond Benc
 * @package 		Phpfox_Component
 * @version 		$Id: add.class.php 1601 2010-05-30 05:20:59Z Raymond_Benc $
 */
class Group_Component_Controller_Add extends Phpfox_Component
{
	/**
	 * Class process method wnich is used to execute this component.
	 */
	public function process()
	{
		Phpfox::isUser(true);
		Phpfox::getUserParam('group.can_create_group', true);
		
		Phpfox_Error::setDisplay(false);
		$bIsEdit = false;
		$sStep = $this->request()->get('step', false);
		$sAction = $this->request()->get('req3', false);
		$aVals = $this->request()->getArray('val');
		
		if ($iEditId = $this->request()->get('id'))
		{
			if (($aGroup = Phpfox::getService('group')->getForEdit($iEditId)))
			{
				$bIsEdit = true;
				$this->setParam('aGroup', $aGroup);				
				$this->setParam(array(
						'country_child_value' => $aGroup['country_iso'],
						'country_child_id' => $aGroup['country_child_id']
					)
				);
				$this->template()->setHeader(array(
							'<script type="text/javascript">$(function(){ var aCategories = explode(\',\', \'' . $aGroup['categories'] . '\'); for (i in aCategories) { $(\'#js_mp_holder_\' + aCategories[i]).show(); $(\'#js_mp_category_item_\' + aCategories[i]).attr(\'selected\', true); } });</script>'
						)
					)
					->assign(array(
						'aForms' => $aGroup,
						'aGroup' => $aGroup
					)
				);
			}
		}		
		
		$aValidation = array(
			'title' => Phpfox::getPhrase('group.provide_a_name_for_this_group'),
			'country_iso' => Phpfox::getPhrase('group.provide_a_location_for_this_group'),
			'short_description' => Phpfox::getPhrase('group.provide_a_short_description_for_this_group'),
			'description' => Phpfox::getPhrase('group.provide_a_description_for_this_group')
		);
		
		if (!empty($aVals['postal_code']))
		{
			$aValidation['postal_code'] = array('def' => 'zip', 'title' => Phpfox::getPhrase('group.zip_postal_code_is_invalid'));				
		}		
				
		$oValidator = Phpfox::getLib('validator')->set(array(
				'sFormName' => 'js_group_form',
				'aParams' => $aValidation
			)
		);		
		
		if (!empty($aVals))
		{
			if ($oValidator->isValid($aVals))
			{				
				if ($bIsEdit)
				{
					if (Phpfox::getService('group.process')->update($aGroup['group_id'], $aVals, $aGroup))
					{
						if (isset($aVals['step']))
						{
							if ($aVals['step'] == 'invite')
							{
								$this->url()->send('group', $aGroup['title_url'], Phpfox::getPhrase('group.successfully_invited_people_to_this_group'));
							}
							else 
							{
								$this->url()->send('group.add', array('id' => $aGroup['group_id'], 'step' => 'invite'));
							}
						}
						else 
						{
							switch ($aVals['action'])
							{
								case 'customize':
									Phpfox::getLib('session')->set('group_add_message', Phpfox::getPhrase('group.successfully_customized_this_group'));
							
									$this->url()->send('group.add.customize', array('id' => $aGroup['group_id']));	
									break;
								case 'invite':
									Phpfox::getLib('session')->set('group_add_message', Phpfox::getPhrase('group.successfully_invited_people_to_this_group'));
							
									$this->url()->send('group.add.invite', array('id' => $aGroup['group_id']));									
									break;
								default:
									Phpfox::getLib('session')->set('group_add_message', Phpfox::getPhrase('group.group_successfully_updated'));
							
									$this->url()->send('group.add', array('id' => $aGroup['group_id']));
									break;
							}							
						}
					}
				}
				else 
				{
					if (($iFlood = Phpfox::getUserParam('group.flood_control_groups')) !== 0)
					{
						$aFlood = array(
							'action' => 'last_post', // The SPAM action
							'params' => array(
								'field' => 'time_stamp', // The time stamp field
								'table' => Phpfox::getT('group'), // Database table we plan to check
								'condition' => 'user_id = ' . Phpfox::getUserId(), // Database WHERE query
								'time_stamp' => $iFlood * 60 // Seconds);	
							)
						);
							 			
						// actually check if flooding
						if (Phpfox::getLib('spam')->check($aFlood))
						{
							Phpfox_Error::set(Phpfox::getPhrase('group.you_are_creating_another_group_a_little_too_soon') . ' ' . Phpfox::getLib('spam')->getWaitTime());	
						}
					}					
					
					if (Phpfox_Error::isPassed())
					{					
						if ($iId = Phpfox::getService('group.process')->add($aVals))
						{
							Phpfox::getLib('session')->set('group_add_message', Phpfox::getPhrase('group.group_successfully_added'));
							
							$this->url()->send('group.add', array('id' => $iId, 'step' => 'customize'));
						}
					}
				}
			}

			$sStep = (isset($aVals['step']) ? $aVals['step'] : '');
			$sAction = (isset($aVals['action']) ? $aVals['action'] : '');			
		}	
		
		$sGroupMessage = '';
		if (($sGroupMessage = Phpfox::getLib('session')->get('group_add_message')))
		{
			Phpfox::getLib('session')->remove('group_add_message');
		}
		
		$this->template()->setTitle(($bIsEdit ? Phpfox::getPhrase('group.edit_group') . ': ' . $aGroup['title'] : Phpfox::getPhrase('group.create_new_group')))
			->setBreadcrumb(Phpfox::getPhrase('group.groups'), $this->url()->makeUrl('group'))
			->setBreadcrumb(($bIsEdit ? Phpfox::getPhrase('group.edit_group') : Phpfox::getPhrase('group.create_new_group')), ($bIsEdit ? $this->url()->makeUrl('group.add', array('id' => $aGroup['group_id'])) : $this->url()->makeUrl('group.add')), ($bIsEdit ? false : true))
			->setEditor()
			->setPhrase(array(
					'core.select_a_file_to_upload'
				)
			)				
			->setHeader('cache', array(					
					'add.js' => 'module_group',
					'pager.css' => 'style_css',
					'progress.js' => 'static_script',					
					'country.js' => 'module_core'			
				)
			)		
			->setHeader(array(
					'<script type="text/javascript">$(function(){$(\'#js_group_block_' . ($sAction ? $sAction : ($sStep ? $sStep : 'detail')) . '\').show();});</script>',
					'<script type="text/javascript">var oProgressBar = {holder: \'#js_upload_inner_form\', progress_id: \'#js_progress_bar\', uploader: \'#js_progress_uploader\', add_more: false, max_upload: 1, total: 1, frame_id: \'js_upload_frame\', file_id: \'image\'};</script>'
				)
			)
			->assign(array(
					'sCreateJs' => $oValidator->createJS(),
					'sGetJsForm' => $oValidator->getJsForm(false),
					'sAction' => ($sAction ? $sAction : 'detail'),	
					'bIsEdit' => $bIsEdit,
					'sStep' => $sStep,
					'sGroupMessage' => $sGroupMessage,
					'sAction' => ($sAction ? $sAction : 'detail'),
					'sCategories' => Phpfox::getService('group.category')->get(),
					'aGroupErrors' => Phpfox_Error::get(),
					'aGroupAccess' => Phpfox::getService('group')->modifyGroupAccess(($bIsEdit ? $aGroup['group_id'] : null)),
					'aGroupPosting' => Phpfox::getService('group')->modifyGroupAccess(($bIsEdit ? $aGroup['group_id'] : null), true),
					'iMaxFileSize' => (Phpfox::getUserParam('group.max_upload_size_group') === 0 ? null : ((Phpfox::getUserParam('group.max_upload_size_group') / 1024) * 1048576)),
					'sJsOnClickLink' => ($bIsEdit ? "if (confirm('" . Phpfox::getPhrase('group.are_you_sure', array('phpfox_squote' => true)) . "')) { $('#js_submit_upload_image').show(); $('#js_group_upload_image').show(); $('#js_group_current_image').remove(); $.ajaxCall('group.deleteImage', 'id=" . $aGroup['group_id'] . "'); } return false;" : "")
				)
			);
			
		if ($bIsEdit)
		{
			$this->template()->setBreadcrumb($aGroup['title'], null, true);
		}
	}
	
	/**
	 * Garbage collector. Is executed after this class has completed
	 * its job and the template has also been displayed.
	 */
	public function clean()
	{
		(($sPlugin = Phpfox_Plugin::get('group.component_controller_add_clean')) ? eval($sPlugin) : false);
	}
}

?>