<?php
/**
 * [PHPFOX_HEADER]
 */

defined('PHPFOX') or exit('NO DICE!');

/**
 * 
 * 
 * @copyright		[PHPFOX_COPYRIGHT]
 * @author  		Raymond Benc
 * @package  		Module_Music
 * @version 		$Id: index.class.php 3073 2011-09-12 13:52:49Z Raymond_Benc $
 */
class Music_Component_Controller_Index extends Phpfox_Component
{
	/**
	 * Class process method wnich is used to execute this component.
	 */
	public function process()
	{		
		Phpfox::getUserParam('music.can_access_music', true);
		
		$aParentModule = $this->getParam('aParentModule');	
		
		if ($this->request()->get('req2') == 'delete' && ($iDeleteId = $this->request()->getInt('id')) && Phpfox::getService('music.process')->delete($iDeleteId))
		{
			$this->url()->send('music', null, 'Song successfully deleted.');
		}
		
		$oServiceSongBrowse = Phpfox::getService('music.song.browse');
		$sView = $this->request()->get('view');
		
		if (($sRedirect = $this->request()->getInt('redirect')) && ($aSong = Phpfox::getService('music')->getSong(Phpfox::getUserId(), $sRedirect, true)))
		{
			$this->url()->send($aSong['user_name'], array('music', ($aSong['album_id'] ? $aSong['album_url'] : 'view'), $aSong['title_url']));
		}
		
		if ($aParentModule === null && $this->request()->getInt('req2'))
		{
			return Phpfox::getLib('module')->setController('music.view');
		}
		
		$bIsProfile = false;
		if (defined('PHPFOX_IS_AJAX_CONTROLLER'))
		{
			$bIsProfile = true;
			$aUser = Phpfox::getService('user')->get($this->request()->get('profile_id'));
			$this->setParam('aUser', $aUser);
		}
		else 
		{		
			$bIsProfile = $this->getParam('bIsProfile');	
			if ($bIsProfile === true)
			{
				$aUser = $this->getParam('aUser');
			}
		}			

		if ($aParentModule === null)
		{
			Phpfox::getService('music')->getSectionMenu();	
		}
		
		$this->template()->setTitle(($bIsProfile ? $aUser['full_name'] . '\'s Songs' : 'Music'))->setBreadcrumb(Phpfox::getPhrase('music.music'), ($bIsProfile ? $this->url()->makeUrl($aUser['user_name'], 'music') : $this->url()->makeUrl('music')));
		
		$this->search()->set(array(
				'type' => 'music_song',
				'field' => 'm.song_id',				
				'search_tool' => array(
					'table_alias' => 'm',
					'search' => array(
						'action' => (defined('PHPFOX_IS_PAGES_VIEW') ? $aParentModule['url'] . 'music/' : ($bIsProfile === true ? $this->url()->makeUrl($aUser['user_name'], array('music', 'view' => $this->request()->get('view'))) : $this->url()->makeUrl('music', array('view' => $this->request()->get('view'))))),
						'default_value' => 'Search Songs...',
						'name' => 'search',
						'field' => 'm.title'
					),
					'sort' => array(
						'latest' => array('m.time_stamp', 'Latest'),
						'most-viewed' => array('m.total_play', 'Most Viewed'),
						'most-liked' => array('m.total_like', 'Most Liked'),
						'most-talked' => array('m.total_comment', 'Most Discussed')
					),
					'show' => array(10, 20, 30)
				)
			)
		);				
		
		$aBrowseParams = array(
			'module_id' => 'music.song',
			'alias' => 'm',
			'field' => 'song_id',
			'table' => Phpfox::getT('music_song'),
			'hide_view' => array('pending', 'my')				
		);
		
		$iGenre = $this->request()->getInt('req3');		
		
		switch ($sView)
		{
			case 'my':
				Phpfox::isUser(true);
				$this->search()->setCondition('AND m.user_id = ' . Phpfox::getUserId());
				break;
			case 'pending':
				Phpfox::isUser(true);
				Phpfox::getUserParam('music.can_approve_songs', true);
				$this->search()->setCondition('AND m.view_id = 1');
				$this->template()->assign('bIsInPendingMode', true);
				break;
			default:
				if ($bIsProfile === true)
				{
					$this->search()->setCondition("AND m.view_id IN(" . ($aUser['user_id'] == Phpfox::getUserId() ? '0,1' : '0') . ") AND m.privacy IN(" . (Phpfox::getParam('core.section_privacy_item_browsing') ? '%PRIVACY%' : Phpfox::getService('privacy')->getForBrowse($aUser)) . ") AND m.user_id = " . $aUser['user_id'] . "");	
				}
				else
				{				
					$this->search()->setCondition("AND m.view_id = 0 AND m.privacy IN(%PRIVACY%)");	
					if ($sView == 'featured')
					{
						$this->search()->setCondition('AND m.is_featured = 1');
					}
				}
				break;
		}
		
		if ($iGenre && ($aGenre = Phpfox::getService('music.genre')->getGenre($iGenre)))
		{
			$this->search()->setCondition('AND m.genre_id = ' . (int) $iGenre);	
			$this->template()->setBreadcrumb($aGenre['name'], $this->url()->permalink('browse.song.genre', $aGenre['genre_id'], $aGenre['name']), true);
		}		
		
		if ($aParentModule !== null)
		{
			$this->search()->setCondition("AND m.module_id = '" . Phpfox::getLib('database')->escape($aParentModule['module_id']) . "' AND m.item_id = " . (int) $aParentModule['item_id']);
		}
		else
		{
			$this->search()->setCondition('AND m.item_id = 0');
		}
		
		$this->search()->browse()->params($aBrowseParams)->execute();		
		
		Phpfox::getLib('pager')->set(array('page' => $this->search()->getPage(), 'size' => $this->search()->getDisplay(), 'count' => $this->search()->browse()->getCount()));		
		
		$this->template()->setHeader('cache', array(
					'pager.css' => 'style_css',
					'comment.css' => 'style_css',
					'feed.js' => 'module_feed',
					'browse.css' => 'module_music'
				)
			)			
			->assign(array(
				'aSongs' => $this->search()->browse()->getRows(),
				'sMusicView' => $sView				
			)
		);
		
		$this->setParam('global_moderation', array(
				'name' => 'musicsong',
				'ajax' => 'music.moderation',
				'menu' => array(
					array(
						'phrase' => 'Delete',
						'action' => 'delete'
					),
					array(
						'phrase' => 'Approve',
						'action' => 'approve'
					),
					array(
						'phrase' => 'Feature',
						'action' => 'feature'
					),
					array(
						'phrase' => 'Un-Feature',
						'action' => 'un-feature'
					)						
				)
			)
		);		
	}
	
	/**
	 * Garbage collector. Is executed after this class has completed
	 * its job and the template has also been displayed.
	 */
	public function clean()
	{
		(($sPlugin = Phpfox_Plugin::get('music.component_controller_index_clean')) ? eval($sPlugin) : false);
	}
}

?>